<?xml version="1.0" encoding="UTF-8"?>
<?xml-stylesheet type="text/xsl" href="configuration.xsl"?>

<configuration>
  <!--source: https://hadoop.apache.org/docs/current/hadoop-project-dist/hadoop-hdfs/HDFSHighAvailabilityWithQJM.html-->
  <property>
    <name>dfs.nameservices</name>
    <value>{{ hdfs.dfs.nameservices }}</value>
  </property>

  <property>
    <name>dfs.ha.namenodes.{{ hdfs.dfs.nameservices }}</name>
    <value>{{ groups.namenodes | map('extract', hostvars, 'namenode_id') | list | join(',') }}</value>
  </property>

  {% for namenode in groups.namenodes %}
  <property>
    <name>dfs.namenode.rpc-address.{{ hdfs.dfs.nameservices }}.{{ hostvars[namenode].namenode_id }}</name>
    <value>{{ namenode }}:8020</value>
  </property>
  {% endfor %}

  {% for namenode in groups.namenodes %}
  <property>
    <name>dfs.namenode.http-address.{{ hdfs.dfs.nameservices }}.{{ hostvars[namenode].namenode_id }}</name>
    <value>{{ namenode }}:9870</value>
  </property>
  {% endfor %}

  <property>
    <name>dfs.namenode.shared.edits.dir</name>
    <!--node[i].example.com is a journalnode and mycluster is nameservice id-->
    <!--expected value: qjournal://node1.example.com:8485;node2.example.com:8485;node3.example.com:8485/mycluster-->
    <!-- solution: https://stackoverflow.com/questions/35183744/jinja2-format-join-the-items-of-a-list#42133657 -->
    <value>qjournal://{{ groups.journalnodes | map('regex_replace', '^(.*)$', '\\1:8485') | list | join(';') }}/{{ hdfs.dfs.nameservices }}</value>
  </property>

  <property>
    <name>dfs.client.failover.proxy.provider.{{ hdfs.dfs.nameservices }}</name>
    <value>org.apache.hadoop.hdfs.server.namenode.ha.ConfiguredFailoverProxyProvider</value>
  </property>

  <!-- <property> -->
  <!--   <name>dfs.ha.fencing.methods</name> -->
  <!--   <value>sshfence([[username][:port]])</value> -->
  <!-- </property> -->

  <property>
    <name>dfs.ha.fencing.methods</name>
    <value>sshfence</value>
  </property>

  <property>
    <name>dfs.ha.fencing.ssh.private-key-files</name>
    <value>{{ hdfs.dfs.ha.fencing.ssh.private_key_files }}</value>
  </property>

  <property> <!-- only if fencing methods is sshfence -->
    <name>dfs.ha.fencing.ssh.connect-timeout</name>
    <value>{{ hdfs.dfs.ha.fencing.ssh.connect_timeout }}</value>
  </property>

  <property>
    <name>dfs.journalnode.edits.dir</name>
    <value>{{ hdfs.dfs.journalnode.edits.dir }}</value>
  </property>

  <property>
    <name>dfs.ha.nn.not-become-active-in-safemode</name>
    <value>true</value>
  </property>

  <!-- source: https://hadoop.apache.org/docs/current/hadoop-project-dist/hadoop-hdfs/HDFSHighAvailabilityWithQJM.html#Automatic_Failover -->
  <property>
     <name>dfs.ha.automatic-failover.enabled</name>
     <value>true</value>
   </property>

  <!--source: https://hadoop.apache.org/docs/current/hadoop-project-dist/hadoop-common/ClusterSetup.html#Configuring_Hadoop_in_Non-Secure_Mode-->
  <property>
    <name>dfs.replication</name>
    <value>{{ hdfs.dfs.replication }}</value>
  </property>

  <property>
    <name>dfs.namenode.name.dir</name>
    <value>file://{{ hdfs.dfs.namenode.name.dir }}</value>
  </property>

  <property>
    <name>dfs.datanode.data.dir</name>
    <value>file://{{ hdfs.dfs.datanode.data.dir }}</value>
  </property>
</configuration>
